# Vahetu Eukleidese algoritm kahe arvu suurima ühsiteguri leidmiseks
def syt(a, b):
    while a != b:
        if a > b:
            a -= b
        else:
            b -= a
    return a


# Lühike algoritm kahe arvu suurima ühsiteguri leidmiseks
def syt2(a, b):
    if b == 0:
        return a
    return syt(b, a % b)


# Kahe arvu vähima ühiskordse leidmine
def vyk(a, b):
    temp = syt2(a, b)
    if temp == 0:
        return 0
    return int(a / temp * b)


# Laiendatud Eukleidese algoritm diofantiliste võrrandite lahendamiseks
def dsyt(a, b, x, y):
    if b == 0:
        x = 1
        y = 0
        ret = [a, x, y]
        return ret
    x1 = 0
    y1 = 0
    s = dsyt(b, a % b, x1, y1)
    syt = s[0]
    x1 = s[1]
    y1 = s[2]
    x = y1
    y = x1 - int(a / b) * y1
    ret = [syt, x, y]
    return ret


# SÜT ja VÜK
a = 1
b = 0
print(syt(40, 24))
print(syt2(40, 24))
print(vyk(40, 24))
d = dsyt(40, 21, a, b)
print(d[0], d[1], d[2])
